#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "invsubs.h"


void LocalSearch(float *s,int nobs,float *obs,int nlooks,float alpha,
                 float maxpert,int nCells,int nImages,int nr,int nc,long *seed)
{
  
  float thisMisfit,lowMisfit,*perturbed,*perturbation;
  int l,n;
  char fname[256];
  FILE *fd0;

  perturbed    = (float *) calloc(nCells, sizeof(float));
  perturbation = (float *) calloc(nCells, sizeof(float));

  ZeroIt(s,nCells);

  lowMisfit = 1e9;
  n = 0;

  for(l = 0; l < nlooks; l++){
    GetPerturbations(perturbation,nCells,nImages,nr,nc,alpha,maxpert,seed);

    SumThem(s,perturbation,nCells);

    thisMisfit =  GetMisfit(perturbation,nCells,nobs,obs);
    
    /*fprintf(stdout,"l = %d, thisMisfit = %f (%f)\n",l,thisMisfit, lowMisfit);*/
    
    if(thisMisfit < lowMisfit)
      {
	lowMisfit = thisMisfit;
	CopyIt(perturbation,s,nCells);
	fprintf(stdout,"Made Transition: l = %d, lowMisfit = %f\n",l,sqrt(lowMisfit)/nobs);
	sprintf(fname,"model%03d",n);
	fd0 = fopen(fname,"w");
	fwrite(s,sizeof(float),(size_t) nr*nc, fd0);
	fclose(fd0);
	n += 1;

      }
  }
}


void ZeroIt(float *x,int n)
{
  int i;
  for(i=0;i<n;i++)
    x[i] = 0;
}

void SumThem(float *x,float *y,int n)
{
  int i;
  for(i=0;i<n;i++)
    y[i] += x[i];
}

void CopyIt(float *x,float *y,int n)
{
  int i;
  for(i=0;i<n;i++)
    y[i] = x[i];
}

void GetPerturbations(float *perturbation,int nCells,int nImages,int nr,int nc,float alpha,float maxpert, long *seed)
{
  int i,nSkip;
  nSkip = nr*nc;
  for(i=0;i<nImages;i++)
    {
      GetPerturbation(&perturbation[i*nSkip],nr,nc,alpha,maxpert,seed);
    }
}




